<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>DependencyHandler (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="DependencyHandler (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/dsl/DependencyHandler.html" target="_top">Frames</a></li>
<li><a href="DependencyHandler.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.artifacts.dsl</div>
<h2 title="Interface DependencyHandler" class="title">Interface DependencyHandler</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="strong">DependencyHandler</span></pre>
<div class="block"><p>A <code>DependencyHandler</code> is used to declare dependencies. Dependencies are grouped into
 configurations (see <a href="../../../../../org/gradle/api/artifacts/Configuration.html" title="interface in org.gradle.api.artifacts"><code>Configuration</code></a>).</p>

 <p>To declare a specific dependency for a configuration you can use the following syntax:</p>

 <pre>
 dependencies {
     <i>configurationName</i> <i>dependencyNotation1</i>, <i>dependencyNotation2</i>, ...
 }
 </pre>

 <p>Example shows a basic way of declaring dependencies.
 <pre class='autoTested'>
 apply plugin: 'java'
 //so that we can use 'compile', 'testCompile' for dependencies

 dependencies {
   //for dependencies found in artifact repositories you can use
   //the group:name:version notation
   compile 'commons-lang:commons-lang:2.6'
   testCompile 'org.mockito:mockito:1.9.0-rc1'

   //map-style notation:
   compile group: 'com.google.code.guice', name: 'guice', version: '1.0'

   //declaring arbitrary files as dependencies
   compile files('hibernate.jar', 'libs/spring.jar')

   //putting all jars from 'libs' onto compile classpath
   compile fileTree('libs')
 }
 </pre>

 <h2>Advanced dependency configuration</h2>
 <p>To do some advanced configuration on a dependency when it is declared, you can additionally pass a configuration closure:</p>

 <pre>
 dependencies {
     <i>configurationName</i>(<i>dependencyNotation</i>){
         <i>configStatement1</i>
         <i>configStatement2</i>
     }
 }
 </pre>

 Examples of advanced dependency declaration including:
 <ul>
 <li>Forcing certain dependency version in case of the conflict.</li>
 <li>Excluding certain dependencies by name, group or both.
      More details about per-dependency exclusions can be found in
      docs for <a href="../../../../../org/gradle/api/artifacts/ModuleDependency.html#exclude(java.util.Map)"><code>ModuleDependency.exclude(java.util.Map)</code></a>.</li>
 <li>Avoiding transitive dependencies for certain dependency.</li>
 </ul>

 <pre class='autoTested'>
 apply plugin: 'java' //so that I can declare 'compile' dependencies

 dependencies {
   compile('org.hibernate:hibernate:3.1') {
     //in case of versions conflict '3.1' version of hibernate wins:
     force = true

     //excluding a particular transitive dependency:
     exclude module: 'cglib' //by artifact name
     exclude group: 'org.jmock' //by group
     exclude group: 'org.unwanted', module: 'iAmBuggy' //by both name and group

     //disabling all transitive dependencies of this dependency
     transitive = false
   }
 }
 </pre>

 More examples of advanced configuration, useful when dependency module has multiple artifacts:
 <ul>
   <li>Declaring dependency to a specific configuration of the module.</li>
   <li>Explicit specification of the artifact. See also <a href="../../../../../org/gradle/api/artifacts/ModuleDependency.html#artifact(groovy.lang.Closure)"><code>ModuleDependency.artifact(groovy.lang.Closure)</code></a>.</li>
 </ul>

 <pre class='autoTested'>
 apply plugin: 'java' //so that I can declare 'compile' dependencies

 dependencies {
   //configuring dependency to specific configuration of the module
   compile configuration: 'someConf', group: 'org.someOrg', name: 'someModule', version: '1.0'

   //configuring dependency on 'someLib' module
   compile(group: 'org.myorg', name: 'someLib', version:'1.0') {
     //explicitly adding the dependency artifact:
     artifact {
       //useful when some artifact properties unconventional
       name = 'someArtifact' //artifact name different than module name
       extension = 'someExt'
       type = 'someType'
       classifier = 'someClassifier'
     }
   }
 }
 </pre>

 <h2>Dependency notations</h2>

 <p>There are several supported dependency notations. These are described below. For each dependency declared this
 way, a <a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts"><code>Dependency</code></a> object is created. You can use this object to query or further configure the
 dependency.</p>

 <p>You can also always add instances of
 <a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts"><code>Dependency</code></a> directly:</p>

 <code><i>configurationName</i> &lt;instance&gt;</code>

 <h3>External dependencies</h3>

 <p>There are two notations supported for declaring a dependency on an external module.
 One is a string notation formatted this way:</p>

 <code><i>configurationName</i> "<i>group</i>:<i>name</i>:<i>version</i>:<i>classifier</i>@<i>extension</i>"</code>

 <p>The other is a map notation:</p>

 <code><i>configurationName</i> group: <i>group</i>, name: <i>name</i>, version: <i>version</i>, classifier:
 <i>classifier</i>, ext: <i>extension</i></code>

 <p>In both notations, all properties, except name, are optional.</p>

 <p>External dependencies are represented by a <a href="../../../../../org/gradle/api/artifacts/ExternalModuleDependency.html" title="interface in org.gradle.api.artifacts"><code>ExternalModuleDependency</code></a>.</p>

 <pre class='autoTested'>
 apply plugin: 'java'
 //so that we can use 'compile', 'testCompile' for dependencies

 dependencies {
   //for dependencies found in artifact repositories you can use
   //the string notation, e.g. group:name:version
   compile 'commons-lang:commons-lang:2.6'
   testCompile 'org.mockito:mockito:1.9.0-rc1'

   //map notation:
   compile group: 'com.google.code.guice', name: 'guice', version: '1.0'
 }
 </pre>

 <h3>Project dependencies</h3>

 <p>To add a project dependency, you use the following notation:
 <p><code><i>configurationName</i> project(':someProject')</code>

 <p>The notation <code>project(':projectA')</code> is similar to the syntax you use
 when configuring a projectA in a multi-module gradle project.

 <p>By default, when you declare dependency to projectA, you actually declare dependency to the 'default' configuration of the projectA.
 If you need to depend on a specific configuration of projectA, use map notation for projects:
 <p><code><i>configurationName</i> project(path: ':projectA', configuration: 'someOtherConfiguration')</code>

 <p>Project dependencies are represented using a <a href="../../../../../org/gradle/api/artifacts/ProjectDependency.html" title="interface in org.gradle.api.artifacts"><code>ProjectDependency</code></a>.

 <h3>File dependencies</h3>

 <p>You can also add a dependency using a <a href="../../../../../org/gradle/api/file/FileCollection.html" title="interface in org.gradle.api.file"><code>FileCollection</code></a>:</p>
 <code><i>configurationName</i> files('a file')</code>

 <pre class='autoTested'>
 apply plugin: 'java'
 //so that we can use 'compile', 'testCompile' for dependencies

 dependencies {
   //declaring arbitrary files as dependencies
   compile files('hibernate.jar', 'libs/spring.jar')

   //putting all jars from 'libs' onto compile classpath
   compile fileTree('libs')
 }
 </pre>

 <p>File dependencies are represented using a <a href="../../../../../org/gradle/api/artifacts/SelfResolvingDependency.html" title="interface in org.gradle.api.artifacts"><code>SelfResolvingDependency</code></a>.</p>

 <h3>Dependencies to other configurations</h3>

 <p>You can add a dependency using a <a href="../../../../../org/gradle/api/artifacts/Configuration.html" title="interface in org.gradle.api.artifacts"><code>Configuration</code></a>.</p>

 <p>When the configuration is from the same project as the target configuration, the target configuration is changed
 to extend from the provided configuration.</p>

 <p>When the configuration is from a different project, a project dependency is added.</p>

 <h3>Gradle distribution specific dependencies</h3>

 <p>It is possible to depend on certain Gradle APIs or libraries that Gradle ships with.
 It is particularly useful for Gradle plugin development. Example:</p>

 <pre class='autoTested'>
 //Our Gradle plugin is written in groovy
 apply plugin: 'groovy'
 //now we can use the 'compile' configuration for declaring dependencies

 dependencies {
   //we will use the Groovy version that ships with Gradle:
   compile localGroovy()

   //our plugin requires Gradle API interfaces and classes to compile:
   compile gradleApi()

   //we will use the Gradle test-kit to test build logic:
   testCompile gradleTestKit()
 }
 </pre>

 <h3>Client module dependencies</h3>

 <p>To add a client module to a configuration you can use the notation:</p>

 <pre>
 <i>configurationName</i> module(<i>moduleNotation</i>) {
     <i>module dependencies</i>
 }
 </pre>

 The module notation is the same as the dependency notations described above, except that the classifier property is
 not available. Client modules are represented using a <a href="../../../../../org/gradle/api/artifacts/ClientModule.html" title="interface in org.gradle.api.artifacts"><code>ClientModule</code></a>.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#add(java.lang.String,%20java.lang.Object)">add</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;configurationName,
   <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation)</code>
<div class="block">Adds a dependency to the given configuration.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#add(java.lang.String,%20java.lang.Object,%20groovy.lang.Closure)">add</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;configurationName,
   <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation,
   <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</code>
<div class="block">Adds a dependency to the given configuration, and configures the dependency using the given closure.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#artifactTypes(org.gradle.api.Action)">artifactTypes</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/type/ArtifactTypeContainer.html" title="interface in org.gradle.api.artifacts.type">ArtifactTypeContainer</a>&gt;&nbsp;configureAction)</code>
<div class="block">Configures the artifact type definitions for this handler.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#attributesSchema(org.gradle.api.Action)">attributesSchema</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a>&gt;&nbsp;configureAction)</code>
<div class="block">Configures the attributes schema.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#components(org.gradle.api.Action)">components</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&gt;&nbsp;configureAction)</code>
<div class="block">Configures component metadata for this project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#create(java.lang.Object)">create</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation)</code>
<div class="block">Creates a dependency without adding it to a configuration.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#create(java.lang.Object,%20groovy.lang.Closure)">create</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation,
      <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</code>
<div class="block">Creates a dependency without adding it to a configuration, and configures the dependency using
 the given closure.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#createArtifactResolutionQuery()">createArtifactResolutionQuery</a></strong>()</code>
<div class="block">Creates an artifact resolution query.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/type/ArtifactTypeContainer.html" title="interface in org.gradle.api.artifacts.type">ArtifactTypeContainer</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#getArtifactTypes()">getArtifactTypes</a></strong>()</code>
<div class="block">Returns the artifact type definitions for this handler.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#getAttributesSchema()">getAttributesSchema</a></strong>()</code>
<div class="block">Returns the attributes schema for this handler.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#getComponents()">getComponents</a></strong>()</code>
<div class="block">Returns the component metadata handler for this project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentModuleMetadataHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#getModules()">getModules</a></strong>()</code>
<div class="block">Returns the component module metadata handler for this project.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#gradleApi()">gradleApi</a></strong>()</code>
<div class="block">Creates a dependency on the API of the current version of Gradle.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#gradleTestKit()">gradleTestKit</a></strong>()</code>
<div class="block">Creates a dependency on the <a href="https://docs.gradle.org/current/userguide/test_kit.html" target="_top">Gradle test-kit</a> API.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#localGroovy()">localGroovy</a></strong>()</code>
<div class="block">Creates a dependency on the Groovy that is distributed with the current version of Gradle.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#module(java.lang.Object)">module</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;notation)</code>
<div class="block">Creates a dependency on a client module.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#module(java.lang.Object,%20groovy.lang.Closure)">module</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;notation,
      <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</code>
<div class="block">Creates a dependency on a client module.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#modules(org.gradle.api.Action)">modules</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentModuleMetadataHandler</a>&gt;&nbsp;configureAction)</code>
<div class="block">Configures module metadata for this project.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a></code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#project(java.util.Map)">project</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;notation)</code>
<div class="block">Creates a dependency on a project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/artifacts/dsl/DependencyHandler.html#registerTransform(org.gradle.api.Action)">registerTransform</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/transform/VariantTransform.html" title="interface in org.gradle.api.artifacts.transform">VariantTransform</a>&gt;&nbsp;registrationAction)</code>
<div class="block">Register an artifact transformation.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="add(java.lang.String, java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;add(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;configurationName,
             <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation)</pre>
<div class="block">Adds a dependency to the given configuration.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configurationName</code> - The name of the configuration.</dd><dd><code>dependencyNotation</code> - The dependency notation, in one of the notations described above.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="add(java.lang.String, java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;add(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;configurationName,
             <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation,
             <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</pre>
<div class="block">Adds a dependency to the given configuration, and configures the dependency using the given closure.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configurationName</code> - The name of the configuration.</dd><dd><code>dependencyNotation</code> - The dependency notation, in one of the notations described above.</dd><dd><code>configureClosure</code> - The closure to use to configure the dependency.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="create(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>create</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;create(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation)</pre>
<div class="block">Creates a dependency without adding it to a configuration.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>dependencyNotation</code> - The dependency notation, in one of the notations described above.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="create(java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>create</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;create(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;dependencyNotation,
                <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</pre>
<div class="block">Creates a dependency without adding it to a configuration, and configures the dependency using
 the given closure.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>dependencyNotation</code> - The dependency notation, in one of the notations described above.</dd><dd><code>configureClosure</code> - The closure to use to configure the dependency.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="module(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>module</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;module(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;notation)</pre>
<div class="block">Creates a dependency on a client module.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>notation</code> - The module notation, in one of the notations described above.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="module(java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>module</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;module(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;notation,
                <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</pre>
<div class="block">Creates a dependency on a client module. The dependency is configured using the given closure before it is
 returned.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>notation</code> - The module notation, in one of the notations described above.</dd><dd><code>configureClosure</code> - The closure to use to configure the dependency.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="project(java.util.Map)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>project</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;project(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;notation)</pre>
<div class="block">Creates a dependency on a project.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>notation</code> - The project notation, in one of the notations described above.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="gradleApi()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>gradleApi</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;gradleApi()</pre>
<div class="block">Creates a dependency on the API of the current version of Gradle.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="gradleTestKit()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>gradleTestKit</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;gradleTestKit()</pre>
<div class="block">Creates a dependency on the <a href="https://docs.gradle.org/current/userguide/test_kit.html" target="_top">Gradle test-kit</a> API.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.6</dd></dl>
</li>
</ul>
<a name="localGroovy()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>localGroovy</h4>
<pre><a href="../../../../../org/gradle/api/artifacts/Dependency.html" title="interface in org.gradle.api.artifacts">Dependency</a>&nbsp;localGroovy()</pre>
<div class="block">Creates a dependency on the Groovy that is distributed with the current version of Gradle.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The dependency.</dd></dl>
</li>
</ul>
<a name="getComponents()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getComponents</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&nbsp;getComponents()</pre>
<div class="block">Returns the component metadata handler for this project. The returned handler can be used for adding rules
 that modify the metadata of depended-on software components.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the component metadata handler for this project</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
<a name="components(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>components</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;components(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentMetadataHandler</a>&gt;&nbsp;configureAction)</pre>
<div class="block">Configures component metadata for this project.

 <p>This method executes the given action against the <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><code>ComponentMetadataHandler</code></a> for this project.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configureAction</code> - the action to use to configure module metadata</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
<a name="getModules()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModules</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentModuleMetadataHandler</a>&nbsp;getModules()</pre>
<div class="block">Returns the component module metadata handler for this project. The returned handler can be used for adding rules
 that modify the metadata of depended-on software components.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the component module metadata handler for this project</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
<a name="modules(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>modules</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;modules(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl">ComponentModuleMetadataHandler</a>&gt;&nbsp;configureAction)</pre>
<div class="block">Configures module metadata for this project.

 <p>This method executes the given action against the <a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><code>ComponentModuleMetadataHandler</code></a> for this project.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configureAction</code> - the action to use to configure module metadata</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
<a name="createArtifactResolutionQuery()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createArtifactResolutionQuery</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/artifacts/query/ArtifactResolutionQuery.html" title="interface in org.gradle.api.artifacts.query">ArtifactResolutionQuery</a>&nbsp;createArtifactResolutionQuery()</pre>
<div class="block">Creates an artifact resolution query.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>2.0</dd></dl>
</li>
</ul>
<a name="attributesSchema(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attributesSchema</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a>&nbsp;attributesSchema(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a>&gt;&nbsp;configureAction)</pre>
<div class="block">Configures the attributes schema. The action is passed a <a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes"><code>AttributesSchema</code></a> instance.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configureAction</code> - the configure action</dd>
<dt><span class="strong">Returns:</span></dt><dd>the configured schema</dd><dt><span class="strong">Since:</span></dt>
  <dd>3.4</dd></dl>
</li>
</ul>
<a name="getAttributesSchema()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAttributesSchema</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/attributes/AttributesSchema.html" title="interface in org.gradle.api.attributes">AttributesSchema</a>&nbsp;getAttributesSchema()</pre>
<div class="block">Returns the attributes schema for this handler.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the attributes schema</dd><dt><span class="strong">Since:</span></dt>
  <dd>3.4</dd></dl>
</li>
</ul>
<a name="getArtifactTypes()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getArtifactTypes</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/artifacts/type/ArtifactTypeContainer.html" title="interface in org.gradle.api.artifacts.type">ArtifactTypeContainer</a>&nbsp;getArtifactTypes()</pre>
<div class="block">Returns the artifact type definitions for this handler.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
<a name="artifactTypes(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>artifactTypes</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;artifactTypes(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/type/ArtifactTypeContainer.html" title="interface in org.gradle.api.artifacts.type">ArtifactTypeContainer</a>&gt;&nbsp;configureAction)</pre>
<div class="block">Configures the artifact type definitions for this handler.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
<a name="registerTransform(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>registerTransform</h4>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;registerTransform(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/artifacts/transform/VariantTransform.html" title="interface in org.gradle.api.artifacts.transform">VariantTransform</a>&gt;&nbsp;registrationAction)</pre>
<div class="block">Register an artifact transformation.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>3.5</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../../../org/gradle/api/artifacts/transform/ArtifactTransform.html" title="class in org.gradle.api.artifacts.transform"><code>ArtifactTransform</code></a></dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/gradle/api/artifacts/dsl/ComponentModuleMetadataHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/artifacts/dsl/DependencyHandler.html" target="_top">Frames</a></li>
<li><a href="DependencyHandler.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
